#include <cassert>
#include <cstdio>
#include <cstring>

#define TASKNAME "robot"

const int MaxN = 102;

bool a [MaxN] [MaxN];
int f [2] [MaxN] [MaxN], p [2] [MaxN] [MaxN];
int ansx [MaxN * MaxN], ansy [MaxN * MaxN];
int k, m, n;

int main (void)
{
 int i, j, l;
 char c;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d %d", &m, &n) != EOF)
 {
  memset (a, 1, sizeof (a));
  for (i = 1; i <= n; i++)
   for (j = 1; j <= m; j++)
   {
    scanf (" %c", &c);
    a[i][j] = (c == 'X');
   }
  for (j = 1; j <= m; j++)
   a[n + 1][j] = a[n][j];
  memset (f, 193, sizeof (f));
  memset (p, 0, sizeof (p));
  for (j = 1; j <= m; j++)
   if (!a[1][j])
  {
   f[0][1][j] = 0;
   f[1][1][j] = 0;
  }
  for (i = 1; i <= n; i++)
  {
   for (j = 1; j <= m; j++)
    if (!a[i][j] && !a[i][j - 1] && f[0][i][j] < f[0][i][j - 1] + 1)
    {
     f[0][i][j] = f[0][i][j - 1] + 1;
     p[0][i][j] = -1;
    }
   for (j = m; j >= 1; j--)
    if (!a[i][j] && !a[i][j + 1] && f[1][i][j] < f[1][i][j + 1] + 1)
    {
     f[1][i][j] = f[1][i][j + 1] + 1;
     p[1][i][j] = 1;
    }
   for (j = 1; j <= m; j++)
    if (!a[i][j] && !a[i + 1][j])
    {
     if (f[0][i][j] > f[1][i][j])
     {
      f[0][i + 1][j] = f[0][i][j] + 1;
      p[0][i + 1][j] = 2;
      f[1][i + 1][j] = f[0][i][j] + 1;
      p[1][i + 1][j] = 2;
//      printf ("%d %d: %d\n", i + 1, j, f[0][i][j] + 1);
     }
     else
     {
      f[0][i + 1][j] = f[1][i][j] + 1;
      p[0][i + 1][j] = 3;
      f[1][i + 1][j] = f[1][i][j] + 1;
      p[1][i + 1][j] = 3;
//      printf ("%d %d: %d\n", i + 1, j, f[1][i][j] + 1);
     }
    }
  }
  k = -1;
  l = 0;
  for (j = 1; j <= m; j++)
   if (k < f[0][n + 1][j])
   {
    k = f[0][n + 1][j];
    l = j;
   }
  printf ("%d\n", k);
  if (k > -1)
  {
   i = n + 1;
   j = l;
   l = 0;
   k = 0;
   while (1)
   {
    ansx[k] = j;
    ansy[k] = i;
//    printf ("%d %d %d: %d\n", l, i, j, p[l][i][j]);
    k++;
    if (!p[l][i][j]) break;
    if (p[l][i][j] < 2)
    {
     j += p[l][i][j];
    }
    else
    {
     l = p[l][i][j] - 2;
     i--;
    }
   }
   for (i = k - 1; i > 0; i--)
    printf ("%d %d\n", ansx[i], ansy[i]);
  }
 }
 return 0;
}
