#include <cassert>
#include <cstdio>
#include <cstring>

#define TASKNAME "scout"

const int MaxN = 62;

int x [MaxN], y [MaxN];
int n;

inline int vp (int x0, int y0, int x1, int y1, int x2, int y2)
{
 return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0);
}

int main (void)
{
 int i, j, k, l, p, q;
 int count;
 freopen (TASKNAME ".in", "r", stdin);
 freopen (TASKNAME ".out", "w", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  count = 0;
  for (i = n - 1; i >= 0; i--)
   for (j = i - 1; j >= 0; j--)
    for (k = i - 1; k >= 0; k--) if (k != j)
     for (l = k - 1; l >= 0; l--) if (l != j)
     {
      p = vp (x[i], y[i], x[j], y[j], x[k], y[k]);
      q = vp (x[i], y[i], x[j], y[j], x[l], y[l]);
      if ((p > 0) == (q > 0)) continue;
      p = vp (x[k], y[k], x[l], y[l], x[i], y[i]);
      q = vp (x[k], y[k], x[l], y[l], x[j], y[j]);
      if ((p > 0) == (q > 0)) continue;
      count++;
     }
  printf ("%d\n", count);
 }
 return 0;
}
