{$B-,I+,N+,O-,Q+,R+,S+}
{$APPTYPE CONSOLE}
Program Check;
uses SysUtils;

const TaskName = 'robot';
 MaxN = 100;
 OK = 0; WA = 1; PE = 2; JE = 3;

var i, j, k, l, m, n: Integer;
 a, b: array [1..MaxN, 1..MaxN] of Boolean;
 buf: String;
 fin, fout, fans: Text;

procedure quit (code: Integer; line: String);
begin
 writeln (line);
 halt (code);
end;

function answer (var stream: Text): Integer;
var i, x, y, x0, y0: Integer;
begin
 b := a;
 read (stream, result);
 x0 := 0; y0 := 0;
 for i := 1 to result do begin
  read (stream, x, y);
  if (x < 1) OR (x > m) OR (y < 1) OR (y > n) OR b[x][y] then begin
   result := -2;
   exit;
  end;
  if i = 1 then if y <> 1 then begin result := -3; exit; end;
  if i = result then if y <> n then begin result := -4; exit; end;
  if i > 1 then
   if (abs (x - x0) + abs (y - y0) <> 1) OR (y < y0) then begin
    result := -5;
    exit;
   end;
  b[x][y] := True;
  x0 := x; y0 := y;
 end;
 if NOT seekeof (stream) then result := -6;
end;

BEGIN
 reset (fin, ParamStr (1));
 readln (fin, m, n);
 assert ((m >= 1) AND (m <= MaxN) AND (n >= 1) AND (n <= MaxN));
 for i := 1 to n do begin
  readln (fin, buf);
  assert (Length (buf) = m);
  for j := 1 to m do
   if buf[j] = 'X' then a[j][i] := True else
    if buf[j] = '.' then a[j][i] := False else
     assert (False);
 end;
 close (fin);
 reset (fans, ParamStr (3));
 k := answer (fans);
 if k < -1 then quit (JE, 'Bad path for jury!');
 close (fans);
 reset (fout, ParamStr (2));
 l := answer (fout);
 if l < -1 then quit (WA, 'Bad path for contestant.');
 close (fout);
 if k < l then
  quit (JE, 'Contestant path is longer!');
 if k > l then
  quit (WA, 'Jury path is longer.');
 quit (OK, 'Jury and contestant agree on an answer.');
END.
