#include <stdio.h>
#include <string.h>

#define MaxM 100
#define Left 0
#define Right 1
#define Up 2

int l;
char a[MaxM + 1][MaxM + 1];
int f[MaxM + 1][MaxM + 2][3];
int r[MaxM * MaxM][2];

int max(int a, int b) {
	return a > b ? a : b;
}

int main(void) {
	int m, n, i, j, best, k, temp, d;
	freopen("robot.in", "rt", stdin);
	freopen("robot.out", "wt", stdout);
	scanf("%d%d\n", &m, &n);
	for (i = 1; i <= n; i++) {
		for (j = 1; j <= m; j++)
			scanf("%c", &a[i][j]);
		scanf("\n");
	}
	memset(f, 0, sizeof(f));
	for (i = 1; i <= n; i++) {
		for (j = 1; j <= m; j++) {
			if (a[i - 1][j] == 'X' || a[i][j] == 'X')
				f[i][j][Up] = -1000000000;
			else
				f[i][j][Up] = max(f[i - 1][j][Left],
						max(f[i - 1][j][Right],
						f[i - 1][j][Up])) + 1;
		}
		for (j = 1; j <= m; j++)
			if (a[i][j] == 'X')
				f[i][j][Left] = -1000000000;
			else
				f[i][j][Left] = max(f[i][j][Left],
						max(f[i][j - 1][Left],
							f[i][j - 1][Up])) + 1;
		for (j = m; j >= 1; j--)
			if (a[i][j] == 'X')
				f[i][j][Right] = -1000000000;
			else
				f[i][j][Right] = max(f[i][j][Right],
						max(f[i][j + 1][Right],
						f[i][j + 1][Up])) + 1;
	}
	best = -1000000000;
	k = 1;
	for (j = 1; j <= m; j++) {
		if (best <= f[n][j][Up]) {
			best = f[n][j][Up];
			k = j;
			d = Up;
		}
		if (best <= f[n][j][Left]) {
			best = f[n][j][Left];
			k = j;
			d = Left;
		}
		if (best <= f[n][j][Right]) {
			best = f[n][j][Right];
			k = j;
			d = Right;
		}			
	}
	if (best <= 0) {
		printf("-1\n");
		return 0;
	}
	else {
		printf("%d\n", best);
		i = n;
		j = k;
		l = 0;
		temp = best;
		while (temp > 0) {
			r[l][0] = i;
			r[l][1] = j;
			l++;
			for (d = 0; d < 3; d++)
				if (f[i][j][d] == temp)
					break;
			temp--;
			if (d == Up)
				i--;
			else if (d == Left)
				j--;
			else if (d == Right)
				j++;
		}
		for (i = l - 1; i >= 0; i--)
			printf("%d %d\n", r[i][1], r[i][0]);
	}
	return 0;
}
